package com.javaseleniumtemplate.pages.EstoquePages;
import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;

public class ImplantacaoEstoquePage extends PageBase {

    //Evento de loading da pagina:
        By loadingWait = By.xpath("//*[@class='zh-loading-desc ng-binding']");
    //BUSCA DO PRODUTO ATRAVES DO FLOAT-CONTROL:
        By iconFloatLupa = By.xpath("//*[@data-zh-id='zh-floating-control-handle']");
        By iconReflesh = By.xpath("//*[@data-zh-id='80926234420126807612533']//*[@data-zh-icon='refresh no-border icon-white']");
        By campoProcurarFloatControl = By.xpath("//*[@id='popup']//*[@placeholder='Procurar']");

    //Aplicando os paramentros no Filtro inicial:
        By clearFilter = By.xpath("//*[@data-zh-id='80926234420126807612533_filter_action_clear']");
        By IconeUnidade = By.xpath("//*[@data-zh-id='80926234421885172782578']//*[@id='NMFILIAL']/span[1]");
        By SelecioanarUnidadeAjusteIventario = By.xpath("//*[@data-zh-field-name='NMFILIAL']//*[.='HELA INGREDIENTES BRASIL']");
        By btnIconAlmoxarifado1 = By.xpath("//*[@data-zh-id='809262344885465619569']//*[@class='zh-icon zh-icon-search zh-icon-no-border']");
        By almoxarifado = By.xpath("//*[@id='grid-9000']//*[.='HELA MATRIZ']");//Nao precisa de data-zh-id
        By IconeData = By.xpath("//*[@data-zh-id='8092623446614594622581']//*[@class='zh-icon zh-icon-calendar zh-icon-no-border']");
        By DataEscolhidaInicial = By.xpath("//*[@id='zh-calendar-Calendar']//*[.='1']");
        By BtnOkFiltro = By.xpath("//*[@id='footer']/div[3]/ul/li/a/span");
        By aplicarFiltro = By.xpath("//*[@data-zh-id='80926234420126807612533_filter_action_never']//span[text() = 'Aplicar filtro']"); //data-zh-id esta vazio

    //Adicionando Implantação de Estoque:
        By btnAdicionar = By.xpath("//*[@id='footer']//*[@data-zh-id='80926234410535704702594']");
        By caixaTextoImplantacaoEstoque = By.xpath("//*[@class='zh-text-alert']");//Nao precisa de data-zh-id
        By btnOkAlert = By.xpath("//*[@class='zh-container-alert']//*[@data-zh-id='zh-footer-alert-button-0']");
        By btnXlimpar = By.xpath("//*[@data-zh-id='8092623446614594622581']//*[@zh-icon='no-border close-x']");
        By btnCalendario = By.xpath("//*[@data-zh-id='8092623446614594622581']//*[@class='zh-icon zh-icon-calendar zh-icon-no-border']");
        By DataEscolhida = By.xpath("//div[@class='day today']");//Nao precisa de data-zh-id
        By campoDescricao = By.xpath("//*[@zh-id='8092623443657433292585']");
        By btnSalvar = By.xpath("//*[@data-zh-id='80926234433852591892600']");
        By btnAdicionar2 = By.xpath("//*[@data-zh-id='8092623444596369402557']");
        By btnIcon = By.xpath("//*[@data-zh-id='80926234414180630162537']//*[@class='zh-icon zh-icon-search zh-icon-no-border']");
        By produto = By.xpath("//*[@id='grid-9000']//*[.='Hela Poultry Broth Paste Clear KG']");//Nao precisa de data-zh-id
        By btnXlimpar2 = By.xpath("//*[@data-zh-id='764527517256954914288']//*[@id='DSALMOXARIFE']/span[2]");
        By btnIconAlmoxarifado2 = By.xpath("//*[@data-zh-id='764527517256954914288']//*[@class='zh-icon zh-icon-search zh-icon-no-border']");
        By campoLote = By.xpath("//*[@data-zh-id='7645275171631791325304']//input");
        By selectLote = By.xpath("//*[@data-zh-id='7645275172186633453300']//*[@tabindex='0']");
        By loteExistente = By.xpath("//*[@data-zh-id='7645275172186633453300']//*[li='Lote Existente']");
        By btnCalendario2 = By.xpath("//*[@data-zh-id='76452751786488369316']//*[@class='zh-icon zh-icon-calendar zh-icon-no-border']");
        By DataEscolhidaAtual = By.xpath("//*[@class='day today']");//Nao precisa de data-zh-id
        By confirmar = By.xpath("//*[@data-zh-id='7645275174220205724322']//*[.='Confirmar']");
        By btnSim = By.xpath("//*[@class='zh-container-alert']//*[@data-zh-id='zh-footer-alert-button-0']");
        By campoQuantidade = By.xpath("//*[@zh-id='80926234441521558402543']");
        By campoVrLiquido = By.xpath("//*[@zh-id='80926234430890756602547']");
        By campoVrBruto = By.xpath("//*[@zh-id='8092623446193716132550']");
        By btnSalvar3 = By.xpath("//*[@data-zh-id='80926234426110987472563']");
        By btnAtualizarEstoque = By.xpath("//*[@data-zh-id='80926234410370767582565']");
        By caixaTextoEstoqueAtualizadoComSucesso = By.xpath("//*[@class='zh-container-alert']");//Nao precisa de data-zh-id
        By btnEstoqueAtualizadoComSucesso= By.xpath("//*[@data-zh-id='zh-footer-alert-button-0']");
        By btnGravar = By.xpath("//*[@data-zh-id='zh-footer-alert-button-0']");

        //EDITAR AJUSTE IVENTARIO:
        By localizandoDescrição = By.xpath("//span[text()='Teste Automatizado']");
        By btnEditar = By.xpath("//*[@id='footer']//*[@data-zh-id ='80926234441741111122590']");
        By campoDescricao2 = By.xpath("//*[@zh-id='8092623443657433292585']");
        By abaProduto = By.xpath("//*[@data-zh-id='masterDetailTabbedWidget']//li[2]/label");
        By btnAdicionar3 = By.xpath("//*[@data-zh-id='8092623444596369402557']");
        By btnIconSearch = By.xpath("//*[@data-zh-id='80926234414180630162537']//*[@class='zh-icon zh-icon-search zh-icon-no-border']");
        By produto2 = By.xpath("//*[@id='grid-9000']//*[.='Geflugelbruhe Paste (Hela 7562510050001)']");

        //----------------------------------------------------------------

        By lote2 = By.xpath("//*[@id='grid-9000']//*[.='20013001']");//Nao precisa de data-zh-id
        By clickCampoQuantidade = By.xpath("//*[@data-zh-field-name='QTTOTLANCTO']//div[1]");
        By sendKeysCampoQuantidade = By.xpath("//*[@data-zh-field-name='QTTOTLANCTO']//input");
        By btnSalvarAlteracoes = By.xpath("//*[@id='footer']//*[.='Salvar alterações']");
        By clickBody = By.xpath("//*[@id='grid-208527946914805240252460']/div[2]/div");
        By IconeOperador = By.xpath("//*[@data-zh-id='208527946916820554232513']//*[@class='zh-icon zh-icon-search zh-icon-no-border']");
        By codOperador = By.xpath("//*[@id='grid-9000']//*[.='000000021846']");
        By lote = By.xpath("//*[@id='grid-9000']//*[.='Teste Alan']");//Nao precisa de data-zh-id
        By quantidadeProduto = By.xpath("//*[@zh-id='208527946938333229262469']");
        By btnSalvar2 = By.xpath("//*[@data-zh-id='208527946940788756772491']");
        By BtnOk = By.xpath("//*[@data-zh-id='zh-footer-alert-button-0']");

    //EXCLUIR IMPLANTACAO DE ESTOQUE:
        By localizandoDescriçãoExcluir = By.xpath("//*[.='Deletar']");
        By btnExcluir = By.xpath("//*[@id='footer']//*[@data-zh-id ='8092623449366967722596']");
        By AlertExcluirRegistro = By.xpath("//*[@class='zh-container-alert']//*[@class='zh-container-text-alert']");

    //Importar Ajuste de inventario:
    By btnImportar = By.xpath("//*[@id='footer']//*[@data-zh-id='8092623441835702972577']");
    By btnEscolherArquivo = By.xpath("//*[@data-zh-id='8092623442400064326911']//*[@id='UPLOADFILE_button']");


    public void preencherFiltroImplantacaoEstoque(String descUnidade,String descAlmoxarifado){

        //FILTRO INICIAL:
        waitForVisibilityOfElementLocated(clearFilter);
        click(clearFilter);
        waitForInvisibilityOfElementLocated(loadingWait);
        //UNIDADE:
        waitForVisibilityOfElementLocated(IconeUnidade);
        click(IconeUnidade);
        waitForInvisibilityOfElementLocated(loadingWait);
            //inicio busca no float-control
                    waitForVisibilityOfElementLocated(campoProcurarFloatControl);
                    click(campoProcurarFloatControl);
                    sendKeys(campoProcurarFloatControl,descUnidade);
                    waitForInvisibilityOfElementLocated(loadingWait);
                //fim busca no float-control
        waitForVisibilityOfElementLocated(SelecioanarUnidadeAjusteIventario);
        click(SelecioanarUnidadeAjusteIventario);
        waitForInvisibilityOfElementLocated(loadingWait);

        //ALMOXARIFADO:
        waitForVisibilityOfElementLocated(btnIconAlmoxarifado1);
        click(btnIconAlmoxarifado1);
        waitForInvisibilityOfElementLocated(loadingWait);
            //inicio busca no float-control
            waitForVisibilityOfElementLocated(campoProcurarFloatControl);
            click(campoProcurarFloatControl);
            sendKeys(campoProcurarFloatControl,descAlmoxarifado);
            waitForInvisibilityOfElementLocated(loadingWait);
            waitForVisibilityOfElementLocated(almoxarifado);
            click(almoxarifado);
            waitForInvisibilityOfElementLocated(loadingWait);
            //fim  busca no float-control

        //DATA:
        waitForVisibilityOfElementLocated(IconeData);
        click(IconeData);
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(DataEscolhidaInicial);
        click(DataEscolhidaInicial); //Data final aparece automaticamente.
        waitForVisibilityOfElementLocated(BtnOkFiltro);
        click(BtnOkFiltro); //data-zh-id esta vazio
        waitForInvisibilityOfElementLocated(loadingWait);
        //APLICAR FILTRO
        waitForVisibilityOfElementLocated(aplicarFiltro);
        click(aplicarFiltro);
        waitForInvisibilityOfElementLocated(loadingWait);

    }
    public void AdicionarImplantacaoEstoque(String quantidade, String cmpDesc,String descProduto,String descAlmoxarifado,String DescCampoLote){
        //INICIO:
        waitForVisibilityOfElementLocated(btnAdicionar);
        click(btnAdicionar);
        //SUB-ABA IMPLANTAÇÃO DE ESTOQUE:
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(caixaTextoImplantacaoEstoque);
        waitForVisibilityOfElementLocated(btnOkAlert);
        click(btnOkAlert);
        waitForVisibilityOfElementLocated(btnXlimpar);
        click(btnXlimpar);
        waitForVisibilityOfElementLocated(btnCalendario);
        click(btnCalendario);
        waitForVisibilityOfElementLocated(DataEscolhida);
        click(DataEscolhida);
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(campoDescricao);
        click(campoDescricao);
        sendKeys(campoDescricao,cmpDesc);
        waitForVisibilityOfElementLocated(btnSalvar);
        click(btnSalvar);
        waitForInvisibilityOfElementLocated(loadingWait);

        //ABA PRODUTOS:
        waitForVisibilityOfElementLocated(btnAdicionar2);
        click(btnAdicionar2);
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(btnIcon);
        click(btnIcon);
        waitForInvisibilityOfElementLocated(loadingWait);
            //inicio busca no float-control
            waitForVisibilityOfElementLocated(campoProcurarFloatControl);
            click(campoProcurarFloatControl);
            sendKeys(campoProcurarFloatControl,descProduto);
            waitForInvisibilityOfElementLocated(loadingWait);
            //fim  busca no float-control
        waitForVisibilityOfElementLocated(produto);
        click(produto); //o nome do prod esta na busca do xpath tbm(nao precisa de zh-id).
        waitForInvisibilityOfElementLocated(loadingWait);

        //SUB FILTRO - INFORMAÇOES COMPLEMENTARES DO PRODUTO:
        waitForVisibilityOfElementLocated(btnXlimpar2);
        click(btnXlimpar2);
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(btnIconAlmoxarifado2);
        click(btnIconAlmoxarifado2);
        waitForInvisibilityOfElementLocated(loadingWait);

            //inicio busca no float-control
                waitForVisibilityOfElementLocated(campoProcurarFloatControl);
                click(campoProcurarFloatControl);
                sendKeys(campoProcurarFloatControl,descAlmoxarifado);
                waitForInvisibilityOfElementLocated(loadingWait);
                waitForVisibilityOfElementLocated(almoxarifado);
                click(almoxarifado);
                waitForInvisibilityOfElementLocated(loadingWait);
            //fim  busca no float-control

        //lote:
            waitForVisibilityOfElementLocated(campoLote);
            click(campoLote);
            sendKeys(campoLote,DescCampoLote);

        //Data de Validade - Calendario:
            waitForVisibilityOfElementLocated(btnCalendario2);
            click(btnCalendario2);
            waitForVisibilityOfElementLocated(DataEscolhidaAtual);
            click(DataEscolhidaAtual);
            waitForInvisibilityOfElementLocated(loadingWait);

        //btn confirmar:
            waitForVisibilityOfElementLocated(confirmar);
            click(confirmar);
            waitForInvisibilityOfElementLocated(loadingWait);
        //caixa de texto:
            waitForVisibilityOfElementLocated(caixaTextoImplantacaoEstoque);
            waitForVisibilityOfElementLocated(btnSim);
            click(btnSim);
            waitForInvisibilityOfElementLocated(loadingWait);
        //aba-produtos -quantidade:
            waitForVisibilityOfElementLocated(campoQuantidade);
            clear(campoQuantidade);
            sendKeys(campoQuantidade,quantidade);
        //aba-produtos -Vr.Liquido:
            waitForVisibilityOfElementLocated(campoVrLiquido);
            clear(campoVrLiquido);
            sendKeys(campoVrLiquido,quantidade);
        //aba-produtos -Vr.Bruto:
            waitForVisibilityOfElementLocated(campoVrBruto);
            clear(campoVrBruto);
            sendKeys(campoVrBruto,quantidade);

        //Salvar/Atualizar Estoque:
            waitForVisibilityOfElementLocated(btnSalvar3);
            click(btnSalvar3);
            waitForInvisibilityOfElementLocated(loadingWait);
            waitForVisibilityOfElementLocated(btnAtualizarEstoque);
            click(btnAtualizarEstoque);
            waitForInvisibilityOfElementLocated(loadingWait);

        //Gravar/Estoque atualizado com sucesso:
            waitForVisibilityOfElementLocated(caixaTextoImplantacaoEstoque);
            waitForVisibilityOfElementLocated(btnGravar);
            click(btnGravar);
            waitForInvisibilityOfElementLocated(loadingWait);
            waitForVisibilityOfElementLocated(caixaTextoEstoqueAtualizadoComSucesso);
            waitForVisibilityOfElementLocated(btnEstoqueAtualizadoComSucesso);
            click(btnEstoqueAtualizadoComSucesso);
            waitForInvisibilityOfElementLocated(loadingWait);

            //inicio - ROTINA DE ATUALIZAR A PAGINA NO FLOAT-CONTROL APOS O LANÇAMENTO
                waitForVisibilityOfElementLocated(iconFloatLupa);
                click(iconFloatLupa);
                waitForVisibilityOfElementLocated(iconReflesh);
                click(iconReflesh);
            //fim - ROTINA DE ATUALIZAR A PAGINA NO FLOAT-CONTROL APOS O LANÇAMENTO



    }
    public void EditarImplantacaoEstoque(String cmpDesc2, String quantidadeEdit,String descProduto2,String descAlmoxarifado,String DescCampoLote){

        //Inicio:
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(localizandoDescrição);
        click(localizandoDescrição);
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(btnEditar);
        click(btnEditar);
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(campoDescricao2);
        click(campoDescricao2);
        clear(campoDescricao2);
        sendKeys(campoDescricao2,cmpDesc2);
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(btnSalvar);
        click(btnSalvar);
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(abaProduto);
        click(abaProduto);
        waitForInvisibilityOfElementLocated(loadingWait);

        //ADICIONANDO O SEGUNDO PRODUTO
        waitForVisibilityOfElementLocated(btnAdicionar3);
        click(btnAdicionar3);
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(btnIconSearch);
        click(btnIconSearch);

            //inicio busca no float-control
            waitForVisibilityOfElementLocated(campoProcurarFloatControl);
            click(campoProcurarFloatControl);
            sendKeys(campoProcurarFloatControl,descProduto2);
            waitForInvisibilityOfElementLocated(loadingWait);
            waitForVisibilityOfElementLocated(produto2);
            click(produto2);
            //fim  busca no float-control

        //SUB FILTRO - INFORMAÇOES COMPLEMENTARES DO PRODUTO:
        waitForVisibilityOfElementLocated(btnXlimpar2);
        click(btnXlimpar2);
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(btnIconAlmoxarifado2);
        click(btnIconAlmoxarifado2);
        waitForInvisibilityOfElementLocated(loadingWait);

            //inicio busca no float-control
            waitForVisibilityOfElementLocated(campoProcurarFloatControl);
            click(campoProcurarFloatControl);
            sendKeys(campoProcurarFloatControl,descAlmoxarifado);
            waitForInvisibilityOfElementLocated(loadingWait);
            waitForVisibilityOfElementLocated(almoxarifado);
            click(almoxarifado);
            waitForInvisibilityOfElementLocated(loadingWait);
            //fim  busca no float-control

        //lote:
            waitForVisibilityOfElementLocated(campoLote);
            click(campoLote);
            sendKeys(campoLote,DescCampoLote);

        //Data de Validade:

            waitForVisibilityOfElementLocated(btnCalendario2);
            click(btnCalendario2);
            waitForVisibilityOfElementLocated(DataEscolhidaAtual);
            click(DataEscolhidaAtual);
            waitForInvisibilityOfElementLocated(loadingWait);
        //btn confirmar:
            waitForVisibilityOfElementLocated(confirmar);
            click(confirmar);
            waitForInvisibilityOfElementLocated(loadingWait);
        //caixa de texto:
            waitForVisibilityOfElementLocated(caixaTextoImplantacaoEstoque);
            waitForVisibilityOfElementLocated(btnSim);
            click(btnSim);
            waitForInvisibilityOfElementLocated(loadingWait);
        //aba-produtos -quantidade:
            waitForVisibilityOfElementLocated(campoQuantidade);
            clear(campoQuantidade);
            sendKeys(campoQuantidade,quantidadeEdit);
        //aba-produtos -Vr.Liquido:
            waitForVisibilityOfElementLocated(campoVrLiquido);
            clear(campoVrLiquido);
            sendKeys(campoVrLiquido,quantidadeEdit);
        //aba-produtos -Vr.Bruto:
            waitForVisibilityOfElementLocated(campoVrBruto);
           clear(campoVrBruto);
            sendKeys(campoVrBruto,quantidadeEdit);

        //Salvar/Atualizar Estoque:
            waitForVisibilityOfElementLocated(btnSalvar3);
            click(btnSalvar3);
            waitForInvisibilityOfElementLocated(loadingWait);
            waitForVisibilityOfElementLocated(btnAtualizarEstoque);
            click(btnAtualizarEstoque);
            waitForInvisibilityOfElementLocated(loadingWait);

        //Gravar/Estoque atualizado com sucesso:
            waitForVisibilityOfElementLocated(caixaTextoImplantacaoEstoque);
            waitForVisibilityOfElementLocated(btnGravar);
            click(btnGravar);
            waitForInvisibilityOfElementLocated(loadingWait);
            waitForVisibilityOfElementLocated(caixaTextoEstoqueAtualizadoComSucesso);
            waitForVisibilityOfElementLocated(btnEstoqueAtualizadoComSucesso);
            click(btnEstoqueAtualizadoComSucesso);
            waitForInvisibilityOfElementLocated(loadingWait);

        //inicio - ROTINA DE ATUALIZAR A PAGINA NO FLOAT-CONTROL APOS O LANÇAMENTO
            waitForVisibilityOfElementLocated(iconFloatLupa);
            click(iconFloatLupa);
            waitForVisibilityOfElementLocated(iconReflesh);
            click(iconReflesh);
        //fim - ROTINA DE ATUALIZAR A PAGINA NO FLOAT-CONTROL APOS O LANÇAMENTO


    }
    public void ExcluirImplantacaoEstoque(){
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(localizandoDescriçãoExcluir);
        click(localizandoDescriçãoExcluir);
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(btnExcluir);
        click(btnExcluir);
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(AlertExcluirRegistro);
        waitForVisibilityOfElementLocated(btnSim);
        click(btnSim);
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(AlertExcluirRegistro);
        waitForVisibilityOfElementLocated(btnOkAlert);
        click(btnOkAlert);

    }

    public void ImportarImplantacaoDeEstoque(){
        //INICIO:
        waitForVisibilityOfElementLocated(btnImportar);
        click(btnImportar);
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(btnEscolherArquivo);
        click(btnEscolherArquivo);

    }

}
