package com.javaseleniumtemplate.pages.EstoquePages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;
import org.openqa.selenium.WebElement;

public class PosicaoDeEstoquePage extends PageBase  {

    //Evento de loading da pagina:
        By loadingWait = By.xpath("//*[@class='zh-loading-desc ng-binding']");


    //BUSCA DO PRODUTO ATRAVES DO FLOAT-CONTROL:
        By iconFloatLupa = By.xpath("//*[@data-zh-id='zh-floating-control-handle']");
        By iconReflesh = By.xpath("//*[@data-zh-id='2085279469498787152459']//*[@data-zh-icon='refresh no-border icon-white']");
        By campoProcurarFloatControl = By.xpath("//*[@id='popup']//*[@placeholder='Procurar']");
        By IconSearch = By.xpath("//*[@data-zh-id='filter-floating-card']//*[@zh-icon='search no-border icon-white']");


    //RELATORIO:
        By tabIndexRelatorio = By.xpath("//*[@data-zh-id='66119073736804857762862']//*[@tabindex = '0']");
        By PosicaoDeEstoque = By.xpath("//*[@data-zh-id='66119073736804857762862']//*[@data-value= '0']");


    //REPETE_CABEÇALHO:
        By tabRepeteCabecalho = By.xpath("//*[@data-zh-id='6611907371524742479136']//*[@tabindex = '0']");
        By OpcaoSim = By.xpath("//*[@data-zh-id='6611907371524742479136']//*[@tabindex = '0']//*[@data-value= '0']");


    //UNIDADE:
        By btnXlimpar = By.xpath("//*[@data-zh-id='6611907373137353202863']//*[@zh-icon='no-border close-x']");
        By IconeUnidade = By.xpath("//*[@data-zh-id='6611907373137353202863']//*[@id='NMFILIAL']/span[1]");
        By SelecioanarUnidadeAjusteIventario = By.xpath("//*[@data-zh-field-name='NMFILIAL']//*[.='HELA INGREDIENTES BRASIL']");


    //DATA_POSIÇÃO:
        By btnXlimparDataPosicao = By.xpath("//*[@data-zh-id='66119073741875895512867']//*[@zh-icon='no-border close-x']");
        By IconCalendario = By.xpath("//*[@data-zh-id='66119073741875895512867']//*[@class='zh-icon zh-icon-calendar zh-icon-no-border']");
        By DataEscolhida = By.xpath("//div[@class='day today']");//Nao precisa de data-zh-id


    //ALMOXARIFADO:
        By IconSearchAlmoxarife = By.xpath("//*[@data-zh-id='6611907378607519402868']//*[@id='DSALMOXARIFE']/span[1]");
        By almoxarifado = By.xpath("//*[@id='grid-9000']//*[.='HELA MATRIZ']");//Nao precisa de data-zh-id


    //TIPO_DE_CUSTO:
        By btnXlimparTipoDeCusto = By.xpath("//*[@data-zh-id='66119073733422378462875']//*[@zh-icon='no-border close-x']");
        By IconSearchTipoDeCusto = By.xpath("//*[@data-zh-id='66119073733422378462875']//*[@id='NMTIPOCUSTO']/span[1]");
        By TipoDeCusto = By.xpath("//*[@id='grid-9000']//*[.='Custo Médio Líquido Atual']");//Nao precisa de data-zh-id


    //NIVEL P/TOTALIZAÇÃO:
        By tabIndexNivelTotalizacao = By.xpath("//*[@data-zh-id='66119073723130806132878']//*[@tabindex = '0']");
        By NivelTotalizacao = By.xpath("//*[@data-zh-id='66119073723130806132878']//*[@data-value= '1']");


    //ORDERNAR POR NOME:
        By tabIndexOrdernarPorNome = By.xpath("//*[@data-zh-id='66119073720788263272879']//*[@tabindex = '0']");
        By OrdernarPorNome = By.xpath("//*[@data-zh-id='66119073720788263272879']//*[@data-value= '0']");


    //PRODUTO INICIAL:
        By IconSearchProdutoInicial = By.xpath("//*[@data-zh-id='66119073733548131952880']//*[@id='NMPRODUTOINI']/span[1]");
        By produto = By.xpath("//*[@id='grid-9000']//*[.='Hela Poultry Broth Paste Clear KG']");//Nao precisa de data-zh-id


    //PRODUTO FINAL:
        By IconSearchProdutoFinal = By.xpath("//*[@data-zh-id='66119073720257794042884']//*[@id='NMPRODUTOFIN']/span[1]");
        By produtoFinal = By.xpath("//*[@id='grid-9000']//*[.='Hela Poultry Broth Paste Clear KG']");//Nao precisa de data-zh-id


    //EM GRID:
        By btnEmGrid = By.xpath("//*[@data-zh-id='6611907374266333116827']");
        //By gridRelatorioPosicao = By.xpath("https://automacao-erp.teknisa.com//est/#/est_relatorios#est31100_grid_relatorio_posicao");


    public void GerarPosicaoDeEstoque(String descUnidade,String descAlmoxarifado,String descTipoDeCusto,String descProduto){

        //RELATORIO:
        waitForInvisibilityOfElementLocated(loadingWait);
       waitForVisibilityOfElementLocated(tabIndexRelatorio);
        click(tabIndexRelatorio);
       waitForVisibilityOfElementLocated(PosicaoDeEstoque);
        click(PosicaoDeEstoque);

        //REPETE_CABEÇALHO:
       waitForVisibilityOfElementLocated(tabRepeteCabecalho);
        click(tabRepeteCabecalho);
        waitForVisibilityOfElementLocated(OpcaoSim);
        click(OpcaoSim);

        //UNIDADE:
        waitForVisibilityOfElementLocated(btnXlimpar);
        click(btnXlimpar);
        waitForVisibilityOfElementLocated(IconeUnidade);
        click(IconeUnidade);
            //inicio busca no float-control
            waitForVisibilityOfElementLocated(IconSearch);
            click(IconSearch);
            waitForInvisibilityOfElementLocated(loadingWait);
            waitForVisibilityOfElementLocated(campoProcurarFloatControl);
            click(campoProcurarFloatControl);
            sendKeys(campoProcurarFloatControl,descUnidade);
            waitForInvisibilityOfElementLocated(loadingWait);
            //fim busca no float-control
        waitForVisibilityOfElementLocated(SelecioanarUnidadeAjusteIventario);
        click(SelecioanarUnidadeAjusteIventario);

        //DATA_POSIÇÃO:
        waitForVisibilityOfElementLocated(btnXlimparDataPosicao);
        click(btnXlimparDataPosicao);
        waitForVisibilityOfElementLocated(IconCalendario);
        click(IconCalendario);
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(DataEscolhida);
        click(DataEscolhida);
        waitForInvisibilityOfElementLocated(loadingWait);

        //ALMOXARIFADO:
        waitForVisibilityOfElementLocated(IconSearchAlmoxarife);
        click(IconSearchAlmoxarife);
        waitForInvisibilityOfElementLocated(loadingWait);
            //inicio busca no float-control
            waitForVisibilityOfElementLocated(campoProcurarFloatControl);
            click(campoProcurarFloatControl);
            sendKeys(campoProcurarFloatControl,descAlmoxarifado);
            waitForInvisibilityOfElementLocated(loadingWait);
            //fim busca no float-control
        waitForVisibilityOfElementLocated(almoxarifado);
        click(almoxarifado);

        //TIPO_DE_CUSTO:
        waitForVisibilityOfElementLocated(btnXlimparTipoDeCusto);
        click(btnXlimparTipoDeCusto);
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(IconSearchTipoDeCusto);
        click(IconSearchTipoDeCusto);
        waitForInvisibilityOfElementLocated(loadingWait);
            //inicio busca no float-control
            waitForVisibilityOfElementLocated(campoProcurarFloatControl);
            click(campoProcurarFloatControl);
            sendKeys(campoProcurarFloatControl,descTipoDeCusto);
            waitForInvisibilityOfElementLocated(loadingWait);
            //fim busca no float-control
        waitForVisibilityOfElementLocated(TipoDeCusto);
        click(TipoDeCusto);
        waitForInvisibilityOfElementLocated(loadingWait);

        //NIVEL P/TOTALIZAÇÃO:
        waitForVisibilityOfElementLocated(tabIndexNivelTotalizacao);
        click(tabIndexNivelTotalizacao);
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(NivelTotalizacao);
        click(NivelTotalizacao);
        waitForInvisibilityOfElementLocated(loadingWait);

        //ORDERNAR POR NOME:
        waitForVisibilityOfElementLocated(tabIndexOrdernarPorNome);
        click(tabIndexOrdernarPorNome);
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(OrdernarPorNome);
        click(OrdernarPorNome);
        waitForInvisibilityOfElementLocated(loadingWait);

        //PRODUTO INICIAL:
        waitForVisibilityOfElementLocated(IconSearchProdutoInicial);
        click(IconSearchProdutoInicial);
        waitForInvisibilityOfElementLocated(loadingWait);
            //inicio busca no float-control
            waitForVisibilityOfElementLocated(campoProcurarFloatControl);
            click(campoProcurarFloatControl);
            sendKeys(campoProcurarFloatControl,descProduto);
            waitForInvisibilityOfElementLocated(loadingWait);
            //fim  busca no float-control
        waitForVisibilityOfElementLocated(produto);
        click(produto); //o nome do prod esta na busca do xpath tbm(nao precisa de zh-id).
        waitForInvisibilityOfElementLocated(loadingWait);

        //PRODUTO FINAL:
        waitForVisibilityOfElementLocated(IconSearchProdutoFinal);
        click(IconSearchProdutoFinal);
        waitForInvisibilityOfElementLocated(loadingWait);
            //inicio busca no float-control
            waitForVisibilityOfElementLocated(campoProcurarFloatControl);
            click(campoProcurarFloatControl);
            sendKeys(campoProcurarFloatControl,descProduto);
            waitForInvisibilityOfElementLocated(loadingWait);
            //fim  busca no float-control
        waitForVisibilityOfElementLocated(produtoFinal);
        click(produtoFinal); //o nome do prod esta na busca do xpath tbm(nao precisa de zh-id).
        waitForInvisibilityOfElementLocated(loadingWait);

        //TIPO ARVORE: --- sem rotina pos os produtos inicial e final ja foram selecionados

        //BOTÃO_EM_GRID:
        waitForVisibilityOfElementLocated(btnEmGrid);
        click(btnEmGrid);
        waitForInvisibilityOfElementLocated(loadingWait);

        //CONFIRMAR SE ESTA NA PAGINA DE RELATORIO GRID:
       // waitForVisibilityOfElementLocated(gridRelatorioPosicao);
    }


}
