package com.javaseleniumtemplate.tests.Estoque;


import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.MovimentacaoDeEstoqueFlows;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.flows.MainFlows;
import com.javaseleniumtemplate.pages.EstoquePages.MovimentacaoDeEstoquePage;
import com.javaseleniumtemplate.pages.MainPage;
import org.testng.annotations.Test;

public class MovimentacaoDeEstoqueTests extends TestBase {

    MainPage mainPage;
    LoginFlows loginFlows;
    MainFlows mainFlows;
    MovimentacaoDeEstoqueFlows movimentacaoDeEstoqueFlows;
    MovimentacaoDeEstoquePage movimentacaoDeEstoquePage;


    @Test(description = "Est-12")
    public void GerarMovimentacaoDeEstoque(){

        //Objects instances
        mainPage = new MainPage();
        loginFlows = new LoginFlows();
        mainFlows = new MainFlows();
        movimentacaoDeEstoqueFlows = new MovimentacaoDeEstoqueFlows();
        movimentacaoDeEstoquePage = new MovimentacaoDeEstoquePage();


        //Parameteres_Lançamento:

        String descProduto = "Hela Poultry Broth Paste Clear KG";
        String descAlmoxarifado = "HELA MATRIZ";
        String descLote = "00154/2023";
        String descUnidade = "HELA INGREDIENTES BRASIL";
        String descTipoDeCusto = "Custo Médio Líquido Atual";


        //Rotinas:
        loginFlows.efetuarLogin();
        mainFlows.AcessandoMovimentacaoDeEstoque();
        movimentacaoDeEstoqueFlows.GerarMovimentacaoDeEstoque(descUnidade,descAlmoxarifado,descLote,descProduto);
        //ajusteInventarioFlows.adicionarAjusteIventario(quantidade,cmpDesc,descProduto,descAlmoxarifado,descLote);

    }

}
