package com.javaseleniumtemplate.tests.Estoque;


import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.RetiradaDeEstoqueFlows;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.flows.MainFlows;
import com.javaseleniumtemplate.pages.EstoquePages.RetiradaDeEstoquePage;
import com.javaseleniumtemplate.pages.MainPage;
import org.testng.annotations.Test;

public class RetiradaDeEstoqueTests extends TestBase{
    MainPage mainPage;
    LoginFlows loginFlows;
    MainFlows mainFlows;
    RetiradaDeEstoqueFlows retiradaDeEstoqueFlows;
    RetiradaDeEstoquePage retiradaDeEstoquePage;


    @Test
    public void EfetuarRetiradaDeEstoque(){

        //Objects instances
        mainPage = new MainPage();
        loginFlows = new LoginFlows();
        mainFlows = new MainFlows();
        retiradaDeEstoqueFlows = new RetiradaDeEstoqueFlows();
        retiradaDeEstoquePage = new RetiradaDeEstoquePage();


        //Parameteres_Lançamento:
        String quantidade = "3";
        String cmpDesc = "Teste Automatizado Retirada de Estoque";
        String descProduto = "Hela Poultry Broth Paste Clear KG";
        String descAlmoxarifado = "HELA MATRIZ";
        String campoSetor = "Administrativo";
        String DescCampoLote = "025/50";
        String descUnidade = "HELA INGREDIENTES BRASIL";
        String valorDevolvido = "1";
        String campoRetirada = "CONSUMO DE PRODUÇÃO";




        //Rotinas:
        loginFlows.efetuarLogin();
        mainFlows.AcessandoRetiradaDeEstoque();
        retiradaDeEstoqueFlows.aplicarFiltro(descUnidade,descAlmoxarifado);
        retiradaDeEstoqueFlows.AdicionarRetiradaEstoque(cmpDesc,descProduto,quantidade,descAlmoxarifado,DescCampoLote,valorDevolvido, campoSetor, campoRetirada);

    }




}