package com.javaseleniumtemplate.dbsteps;

import com.javaseleniumtemplate.utils.DBUtils;
import com.javaseleniumtemplate.utils.Utils;
import java.util.List;

public class DBSteps {
    private static String queriesPath = "src/test/java/com/javaseleniumtemplate/queries/";


    public static String retornaSenhaDoUsuarioDB(String usuario) {
        String query = Utils.getFileContent(queriesPath + "retornaSenhaDoUsuario.sql")
                .replace("$usuario", usuario);

        return DBUtils.getQueryResult(query).get(0);
    }

    public static String retornaQuatidadeEstoque(String numeroLancamento) {
        String query = Utils.getFileContent(queriesPath + "retornaQuantidadeEstoque.sql")
                .replace("$ntlancestq", numeroLancamento);
        return DBUtils.getQueryResult(query).get(0);
    }

    public static String retornaValorTotalQuantidadeEstoque(String valorLancamentoTotalEstoque) {
        String query = Utils.getFileContent(queriesPath + "retornaValorTotalQuantidadeEstoque.sql")
                .replace("$ntlancestq", valorLancamentoTotalEstoque);
        return DBUtils.getQueryResult(query).get(0);
    }
}
